CREATE TABLE IF NOT EXISTS steam_id_tbl (
    "id" INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
    "steam_id" INTEGER NOT NULL UNIQUE
);
CREATE TABLE IF NOT EXISTS player_name_tbl (
    "id" INTEGER NOT NULL PRIMARY KEY AUTOINCREMENT,
    "name" TEXT NOT NULL UNIQUE
);
CREATE TABLE IF NOT EXISTS steam_id_player_name_reference_tbl (
    "steam_id_id" INTEGER NOT NULL REFERENCES "steam_id_tbl" ("id"),
    "player_name_id" INTEGER NOT NULL REFERENCES "player_name_tbl" ("id"),
    UNIQUE ("steam_id_id", "player_name_id")
);
CREATE TABLE IF NOT EXISTS all_logins_steam_id_tbl (
    "timestamp" TIME NOT NULL,
    "steam_id_id" INTEGER NOT NULL REFERENCES "steam_id_tbl" ("id"),
    UNIQUE("timestamp", "steam_id_id")
);
CREATE TABLE IF NOT EXISTS all_logins_player_name_tbl (
    "timestamp" TIME NOT NULL,
    "player_name_id" INTEGER NOT NULL REFERENCES "player_name_tbl" ("id"),
    UNIQUE("timestamp", "player_name_id")
)