"""
[summary]

[extended_summary]
"""

# region [Imports]

# * Standard Library Imports ------------------------------------------------------------------------------------------------------------------------------------>


from typing import Tuple

# * Third Party Imports ----------------------------------------------------------------------------------------------------------------------------------------->

# import discord

# import requests

# import pyperclip

# import matplotlib.pyplot as plt

# from bs4 import BeautifulSoup

# from dotenv import load_dotenv

# from discord import Embed, File

# from discord.ext import commands, tasks

# from github import Github, GithubException

# from jinja2 import BaseLoader, Environment

# from natsort import natsorted

# from fuzzywuzzy import fuzz, process


# * Gid Imports ------------------------------------------------------------------------------------------------------------------------------------------------->

import gidlogger as glog


# * Local Imports ----------------------------------------------------------------------------------------------------------------------------------------------->

import pandas as pd

# endregion[Imports]

# region [TODO]


# endregion [TODO]

# region [AppUserData]


# endregion [AppUserData]

# region [Logging]

log = glog.aux_logger(__name__)


# endregion[Logging]

# region [Constants]

# endregion[Constants]


class OutputItem:

    default_file_name = 'steam_id_names.xlsx'

    def __init__(self) -> None:
        self.data = {}

    def add_data(self, steam_id: int, player_name: Tuple[str, int]):
        if steam_id not in self.data:
            self.data[steam_id] = {'logins': 0, 'name_data': {}}
        self.data[steam_id]['name_data'][player_name[0]] = player_name[1]

    def add_login_count(self, steam_id: int):
        if steam_id not in self.data:
            self.data[steam_id] = {'logins': 0, 'name_data': {}}
        self.data[steam_id]['logins'] += 1

    @property
    def amount_name_columns(self):
        all_name_amounts = [len(value.get('name_data').keys()) for key, value in self.data.items()]
        return max(all_name_amounts)

    @property
    def as_dataframe(self) -> pd.DataFrame:
        item_dict = {'steam_id': "", 'login_amount': 0}
        for i in range(self.amount_name_columns):
            _i = i + 1
            item_dict[f"player_name_{_i}"] = None
            item_dict[f"player_name_{_i}_login_amount"] = None
        items = []
        for key, value in self.data.items():
            _item_dict = item_dict.copy()
            _item_dict['steam_id'] = str(key)
            _item_dict['login_amount'] = value.get('logins')
            for index, name_data in enumerate(value.get('name_data').items()):
                _item_dict[f'player_name_{index+1}'] = name_data[0]
                _item_dict[f"player_name_{index+1}_login_amount"] = name_data[1]

            items.append(_item_dict)
        return pd.DataFrame.from_records(items)

    def to_excel(self, file_name: str = None):
        file_name = self.default_file_name if file_name is None else file_name
        # path = pathmaker(self.desktop, file_name)
        self.as_dataframe.to_excel(file_name)


# region[Main_Exec]
if __name__ == '__main__':
    pass

# endregion[Main_Exec]
