"""
[summary]

[extended_summary]
"""

# region [Imports]

# * Standard Library Imports ------------------------------------------------------------------------------------------------------------------------------------>


import os


# * Third Party Imports ----------------------------------------------------------------------------------------------------------------------------------------->

# import discord

# import requests

# import pyperclip

# import matplotlib.pyplot as plt

# from bs4 import BeautifulSoup

# from dotenv import load_dotenv

# from discord import Embed, File

# from discord.ext import commands, tasks

# from github import Github, GithubException

# from jinja2 import BaseLoader, Environment

# from natsort import natsorted

# from fuzzywuzzy import fuzz, process

import gidlogger as glog
from antistasi_console_log_parser.utils.misc import writejson, loadjson, pathmaker
# endregion[Imports]

# region [TODO]


# endregion [TODO]

# region [AppUserData]


# endregion [AppUserData]

# region [Logging]

log = glog.aux_logger(__name__)
log.info(glog.imported(__name__))

# endregion[Logging]

# region [Constants]


# endregion[Constants]

class FileHasher:
    hash_data_file = pathmaker(os.getenv("APP_DATA_FOLDER"), 'parsed_file_hashes.json')

    def __init__(self) -> None:
        if os.path.isfile(self.hash_data_file) is False:
            writejson([], self.hash_data_file)

    @property
    def all_hashes(self):
        return loadjson(self.hash_data_file)

    @all_hashes.setter
    def all_hashes(self, value):
        value = list(set(value))
        writejson(value, self.hash_data_file)

    def __contains__(self, other):
        if other in set(self.all_hashes):
            return True
        return False

    def append(self, value):
        data = self.all_hashes
        data.append(value)
        self.all_hashes = data


# region[Main_Exec]
if __name__ == '__main__':
    pass

# endregion[Main_Exec]
